# Malta UTD Import Service for RAVEN

**RAVEN** is an open source web based Air Quality data validation and e-reporting system, with the aim to control the flow, metadata inventory, the quality of the monitoring data and producing the XML files required for the Air Quality B-G, except from D1b (Information on the assessment methods - for models and objective estimation) and E1b (Information on primary validated assessment data – modelled).  
The system is managed and developed by `NILU`, with support from `4sFera`, on the behalf of the `European Environmental Agency`.

## Requirements

Python version `3.10.8`  

## Download and unpack the code
https://git.nilu.no/raven/Malta_UTD_Import_Service/-/archive/main/Malta_UTD_Import_Service-main.zip

## Configuration
Configuration of RAVEN URLs and which sampling point data one wants to fetch is to be done in the Config.json file

For unit conversion, for instance from ppm to ug/m3, one need to add conversion factor for each sampling point. This can be done in the "Convert" form in RAVEN web application.

To include some simple automatic quality control one can add max, min and repeated allow values in a row. This can be done in the "Auto Validate" form in RAVEN web application.

**Install the required python packages**

```powershell
pip install -r requirements.txt
```
**Run script using Windows Scheduler**
Follow instruction HOW TO INTALL PYTHON RAVEN MALTA SCRIPT.docx - https://git.nilu.no/raven/Malta_UTD_Import_Service/-/blob/main/HOW%20TO%20INTALL%20PYTHON%20RAVEN%20MALTA%20SCRIPT.docx
