import jsonpath_ng.ext as jp
from datetime import datetime,timedelta
import csv


def FillRavenMapping(Agg_value,data,RavenMappingStationChannel,RavenMapping,infoSt,i,validity):
    
    formatEkstra = data['Readings'][0]['Time']
    formatEkstraDone = formatEkstra[:-5] + "00.00"   
    unformatted_datetime = data['Readings'][0]['Date'] + " " +  formatEkstraDone #data['Readings'][0]['Time']
    formatted_datetime_from = datetime.strptime(unformatted_datetime, "%Y%m%d %H:%M.%S")
    formatted_datetime_to = formatted_datetime_from + timedelta(hours=1)   
    #timezone adding one hour to Raven
    formatted_datetime_from = formatted_datetime_from + timedelta(hours=1) 
    formatted_datetime_to = formatted_datetime_to + timedelta(hours=1) 

    fromtime = formatted_datetime_from.strftime("%Y-%m-%dT%H:%M:%S+01")
    totime = formatted_datetime_to.strftime("%Y-%m-%dT%H:%M:%S+01")

    count:int = i #len(data['Readings'])

    RavenMapping['values'][0]['logger_id'] = infoSt + "_" + RavenMappingStationChannel['Channel_ID']
    RavenMapping['values'][0]['fromTime'] = fromtime
    RavenMapping['values'][0]['toTime'] = totime
    RavenMapping['values'][0]['value'] = Agg_value
    if count==4: RavenMapping['values'][0]['validity'] = 100 
    if count==3: RavenMapping['values'][0]['validity'] = 75 
    if count==2: RavenMapping['values'][0]['validity'] = 50     #new code line
    if count<2: RavenMapping['values'][0]['validity'] = 0       #change from <3 to <2
    if validity == -1:  RavenMapping['values'][0]['validity'] = 0
    return RavenMapping    

def MakeRavenMappingJsonObject():
    RavenMapping = {
    "values": [

        {
            "logger_id": "some-logger-id",
            "fromTime": "YYYY-MM-DDTHH24:ss:mmZ",
            "toTime": "YYYY-MM-DDTHH24:ss:mmZ",
            "value": "float value",
            "validity": "integer value bewtween 1-100. Over 75 is valid"
        }
    ]    
    }
    return RavenMapping

def CreateCSVfile(Agg_value,metadata,RavenMappingStationChannel,iCountValidValues,validity,qa_flag,qc_flag,iCountFlagged):
    # Create a CSV file
    
    formatEkstra = metadata['Readings'][0]['Time']
    formatEkstraDone = formatEkstra[:-5] + "00.00"   
    unformatted_datetime = metadata['Readings'][0]['Date'] + " " +  formatEkstraDone #data['Readings'][0]['Time']
    formatted_datetime_from = datetime.strptime(unformatted_datetime, "%Y%m%d %H:%M.%S")
    formatted_datetime_to = formatted_datetime_from + timedelta(hours=1)   
    #timezone adding one hour to Raven
    formatted_datetime_from = formatted_datetime_from + timedelta(hours=1) 
    formatted_datetime_to = formatted_datetime_to + timedelta(hours=1) 

    fromtime = formatted_datetime_from.strftime("%Y-%m-%dT%H:%M:%S+01")
    totime = formatted_datetime_to.strftime("%Y-%m-%dT%H:%M:%S+01")

    count:int = iCountValidValues #len(data['Readings'])
    if count==4: qa_flag = 1 
    if count==3: qa_flag = 1 
    if count<3: 
        if qa_flag != -99: qa_flag = -1        
        if iCountFlagged == 0: Agg_value = -9900
       
    if validity == -1:  qa_flag = -1 

    sample_point_id = RavenMappingStationChannel['Sampling_point_id']
       
    data =  [
            {"sampling_point_id": sample_point_id, "begin_position": fromtime, "end_position": totime,"value": Agg_value,"validation_flag": qa_flag, "verification_flag" : qc_flag}   
            ]
    filename = "observations.csv"

    headers = data[0].keys()

    # Open the file in write mode
    with open(filename, mode='w', newline='') as file:
    # Create a DictWriter object, passing the file object and headers
        writer = csv.DictWriter(file, fieldnames=headers)
    
    # Write the headers
        writer.writeheader()
    
    # Write the data
        writer.writerows(data)
    return filename
