import json
import jsonpath_ng.ext as jp
from datetime import datetime,timedelta
import request
import RavenMap
import logging
import calendar
from dateutil.relativedelta import relativedelta

# Example: Perform more complex queries using libraries like jsonpath-ng

currentDateTime = datetime.now()

json_log_file_path = r'C:\Project\Malta_UTD_Import_Service\myPythonRaven.log'   
# Configure logging
logging.basicConfig(filename=json_log_file_path, level=logging.ERROR, format='%(asctime)s - %(levelname)s - %(message)s')

json_file_path = r'C:\Project\Malta_UTD_Import_Service\config.json'       

# Load the JSON file
with open(json_file_path, 'r') as file:
    configRaven = json.load(file)

# Query the JSON data
# Example: Iterate over a list within the JSON data
# Test OK

def GetFromDateTimeAndToDateTime(lastentry):
    if type(lastentry) != datetime:
        lastFromDateTime =  datetime.strptime(lastentry, "%Y-%m-%d %H:%M:%S")    
    else: lastFromDateTime = lastentry

    if lastFromDateTime.month < 10:  lastFromDateUrl:str = str(lastFromDateTime.year) + "0" + str(lastFromDateTime.month)
    else: lastFromDateUrl:str = str(lastFromDateTime.year) +  str(lastFromDateTime.month) 
    if lastFromDateTime.day < 10: lastFromDateUrl = lastFromDateUrl + "0" + str(lastFromDateTime.day)
    else: lastFromDateUrl = lastFromDateUrl + str(lastFromDateTime.day)

    nextHour: datetime = lastFromDateTime + timedelta(hours=1)    
    if lastFromDateTime.month < 10: lastToDateUrl:str = str(nextHour.year) + "0" + str(lastFromDateTime.month) 
    else: lastToDateUrl:str = str(nextHour.year) +  str(lastFromDateTime.month) 
    if lastFromDateTime.day < 10:  lastToDateUrl = lastToDateUrl + "0" + str(lastFromDateTime.day)
    else: lastToDateUrl = lastToDateUrl + str(lastFromDateTime.day)

    if lastFromDateTime.hour == 23:
        midnight =  lastFromDateTime + timedelta(days=1)             
        last_day = calendar.monthrange(lastFromDateTime.year, lastFromDateTime.month)[1]

        if last_day == lastFromDateTime.day:
            midnightmonth = lastFromDateTime + relativedelta(months=+1) 
            if midnightmonth.month < 10: lastToDateUrl:str = str(nextHour.year) + "0" + str(midnightmonth.month) + "0" + str(midnight.day)
            else: lastToDateUrl:str = str(nextHour.year) +  str(midnightmonth.month) +  "0" + str(midnight.day)               
        else:
            if lastFromDateTime.month < 10: lastToDateUrl:str = str(nextHour.year) + "0" + str(lastFromDateTime.month) 
            else: lastToDateUrl:str = str(nextHour.year) +  str(lastFromDateTime.month)                
        
            if lastFromDateTime.day < 10: lastToDateUrl = lastToDateUrl + "0" + str(midnight.day)
            else: lastToDateUrl = lastToDateUrl + str(midnight.day)      

    if lastFromDateTime.hour < 10:  lastFromTime:str = "0" + str(lastFromDateTime.hour) + "0100"
    else: lastFromTime:str = str(lastFromDateTime.hour) + "0100"#+ str(lastFromDateTime.minute) #+ str(lastFromDateTime.second)
    
    if lastFromDateTime.hour < 10: lastToTime:str = "0" + str(nextHour.hour) + "0000"
    lastToTime:str = str(nextHour.hour) + "0000"#str(nextHour.minute) #+ str(nextHour.second)     
    
    return lastFromDateUrl,lastToDateUrl,lastFromTime,lastToTime
#--------------------------------------------------------------------------------------------------------

def GetDiffNowLastentry(lastentry):
    date_diff = currentDateTime - lastentry
    if date_diff.total_seconds() > 0:
        hours_diff = date_diff.total_seconds() / 3600
    else:
        hours_diff = 0
    hours_diff = round(hours_diff)
    return date_diff.days, hours_diff
#--------------------------------------------------------------------------------------------------------   


def Main():
        
    try:
        data,ErrorMsg = request.ResponseGet(GETurl,logging)
        if len(ErrorMsg) > 0: return
        
        infoSt =  data['Station Name']
        infoSt = infoSt.replace(" ","")
        infoRd = data['Readings'][0]                 
       
        RavenMapping = RavenMap.MakeRavenMappingJsonObject()
        RavenCsv:str = ""

        for RavenMappingStationChannel in RavenMappingStationChannels:            
            Agg_value = 0.0    
            iCountValidValues = 0
            validty = 0    
            qa_flag = 0
            qc_flag = 3
            iCountFlagged = 0
            iTestCount = 0

            #TestDatafiltered_data = [1,2,3,4]
            #TestDataStatus = ['0x0000', '0x0000', '0x0080', '0x0080']            

            for itemReading in data['Readings']:
                filtered_data = [item for item in itemReading['Channels'] if item['Channel'] == int(RavenMappingStationChannel['Channel_ID'])]
                Status = filtered_data[0]['GatewayStatus']           

                #filtered_data[0]['Raw'] = TestDatafiltered_data[iTestCount]
                #Status = TestDataStatus[iTestCount]

                if Status == '0x0000':
                    if filtered_data[0]['Raw'] != -999:                           
                        Agg_value += filtered_data[0]['Raw']
                        iCountValidValues += 1
                        qa_flag = 1
                
                if Status == '0x1100': #invalid + flagged
                    if filtered_data[0]['Raw'] != -999:
                       iCountValidValues=iCountValidValues                       
                       qa_flag = -1    
               
                if Status == '0x1000':  #invalid status
                    if filtered_data[0]['Raw'] != -999:
                       iCountValidValues=iCountValidValues
                       qa_flag = -1                        

                if Status == '0x0100': #data has been flagged
                    if filtered_data[0]['Raw'] != -999:
                        Agg_value += filtered_data[0]['Raw']
                        iCountValidValues=iCountValidValues
                        iCountFlagged += 1                                                                        

                if Status == '0x0010': #indicating calabration in progress
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -99                      

                if Status == '0x0001': #status code for invalid data
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -1 
                       
                if Status == '0x0002': #status code for in service
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -1 
                       
                if Status == '0x0004': #status code for in service
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -1 
                      
                if Status == '0x0008': #if invalid data, and 'Flag invalid data' ticked in setup
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -1
                   
                if Status == '0x0020': #if analogue channel is used as status, then alarm flag
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -1                          
                   
                if Status == '0x0040': #user marked data invalid
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -1 
                    
                if Status == '0x0080': #calibration in progress
                    if filtered_data[0]['Raw'] != -999:
                         iCountValidValues=iCountValidValues
                         qa_flag = -99                    

                #iTestCount += 1
            if iCountValidValues > 0:     
                Agg_value = Agg_value/(iCountValidValues+iCountFlagged)
            
               # RavenMapping = RavenMap.FillRavenMapping(Agg_value, data,RavenMappingStationChannel,RavenMapping,infoSt,i,validty)                
               # request.ResponsePost(RavenMapping,headers,RequestPost,logging)     

                RavenCsv = RavenMap.CreateCSVfile(Agg_value, data,RavenMappingStationChannel,iCountValidValues,validty,qa_flag,qc_flag,iCountFlagged)                
                request.ResponsePostFile(RavenCsv,headers,RequestPostFlags,logging)
                

    except Exception as e:
        logging.error(f"An error occurred: {e}")
        #print(f"An error occurred: {e}")
#--------------------------------------------------------------------------------------------------------


# Example: Access nested objects within the JSON data
RavenMappingConfig = configRaven['config_data'][0]
FirstStartDate = RavenMappingConfig['First_Start_Date']
FirstStartFromTime = RavenMappingConfig['First_Start_FromTime']
SignInUrl = RavenMappingConfig['SignInUrl']
RequestPost = RavenMappingConfig['RequestPost']
RequestPostFlags = RavenMappingConfig['RequestPostFlags']

TimeStampUrl = RavenMappingConfig['TimeStampUrl']
GetUrl = RavenMappingConfig['GetUrl']

for itemRavenMappingConfig in RavenMappingConfig['Raven_Mapping_Config']:
    RavenMappingStationID= itemRavenMappingConfig['StationID'] 
    RavenMappingStationName= itemRavenMappingConfig['StationName']
    RavenMappingStationChannels= itemRavenMappingConfig['Channels']

    auth_token = request.RavenSignin(SignInUrl)    
    headers = {'Authorization': f'Bearer {auth_token}'}
        
    lastentry = request.GetUrlTimeStamp(RavenMappingStationName,itemRavenMappingConfig,headers,TimeStampUrl,logging)

    if lastentry != None: 
        lastentry =  datetime.strptime(lastentry, "%Y-%m-%d %H:%M:%S")
        lastentry = lastentry + timedelta(hours=-1)
        
        datediff,hourdiff = GetDiffNowLastentry(lastentry)        
        for i in range(hourdiff):
            current_date = lastentry + timedelta(hours=i)            
            if i==0: lastFromDateUrl,lastToDateUrl,lastFromTime,lastToTime = GetFromDateTimeAndToDateTime(lastentry)
            else: lastFromDateUrl,lastToDateUrl,lastFromTime,lastToTime = GetFromDateTimeAndToDateTime(current_date)          
           
            GETurl = GetUrl + RavenMappingStationID +"&DateFrom="+ lastFromDateUrl + "&TimeFrom=" + lastFromTime +"&DateTo=" + lastToDateUrl + "&TimeTo=" + lastToTime + "&GMT=0&PID="           
            Main() 
    

    if lastentry == None:     
        GETurl =  GetUrl + RavenMappingStationID +"&DateFrom="+ FirstStartDate + "&TimeFrom=" + FirstStartFromTime + "&DateTo=" + FirstStartDate +"&TimeTo=" + "005900" + "&GMT=0&PID="     
        Main()    
         
   

