import requests
import json
import csv

def RavenSignin(url):   
    responseToken = requests.post(url, json={'username':'admin', 'password':'admin'})
    if responseToken.status_code == 200:
        json_data = json.loads(responseToken.content)
        authToken = json_data['token']
    return authToken

def ResponseGet(GETurl,logging):
    try:
        resp = requests.get(url=GETurl)
        clean = resp.text.replace("<br>","")
        data = json.loads(clean)
        response_json = resp.json()
        message: str = ""
        if "success" in response_json:
                message = "Success: " + str(response_json['success'])
                logging.error(f"Success: " + str(response_json['success']))
        if "Message" in response_json:   
                message = "Error: " + str(response_json['Message'])
                logging.error(f"Error: " + str(response_json['Message']))
        if "msg" in response_json:   
                message = "Error: " + str(response_json['msg'])
                logging.error(f"Error: " + str(response_json['msg']))
        #print(message)
        return data,message
    except Exception as e:
        #print(f"An error occurred: {e}")
        logging.error(f"An error occurred: {e}")

def ResponsePost(RavenMapping,headers,url,logging):
     response_post = requests.post(url, json=RavenMapping, headers=headers)
     response_json = response_post.json()
     if "success" in response_json:
          logging.error(f"Success: " + str(response_json['success']) + "," +  RavenMapping['values'][0]['logger_id'] + "," + RavenMapping['values'][0]['fromTime']  + "," + str(RavenMapping['values'][0]['value']))
     else:
          logging.error(f"Error: " + str(response_json['msg']) + "," +  RavenMapping['values'][0]['logger_id'])

def ResponsePostFile(RavenCsvfilename,headers,url,logging):
     
     FILES = {'file': open(RavenCsvfilename, 'rb')}
     response_post = requests.post(url, files=FILES, headers=headers)
     response_json = response_post.json()
     
     with open(RavenCsvfilename, mode='r') as file:        
        csv_reader = csv.DictReader(file)       
        
        for row in csv_reader:      
            if "success" in response_json:                    
                logging.error(f"Success: " + str(response_json['success']) + "," +  row['sampling_point_id'] + "," + row['begin_position']  + "," + str(row['value']))
            else:
                logging.error(f"Error: " + str(response_json['msg']) + "," +  row['sampling_point_id'])


def GetUrlTimeStamp(RavenMappingStationName,itemRavenMappingConfig,headers,urlTimeStamp,logging):
    try:
        urlTimeStamp = urlTimeStamp + RavenMappingStationName.upper() + "_" + itemRavenMappingConfig['Channels'][0]['Channel_ID']
        respTimeStamp = requests.get(url=urlTimeStamp,headers=headers)
        respTimeStamp = respTimeStamp.json()    
        lastentry = respTimeStamp['lastEntry']
        return lastentry
    except Exception as e:
         logging.error(f"An error occurred: {e}")
